diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
index b95e9e87b..2c115e831 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
@@ -11,10 +11,10 @@ import net.minecraft.core.block.entity.TileEntityStatue;
 import net.minecraft.core.entity.IArmorWearing;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.*;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 import org.useless.dragonfly.DisplayPos;
@@ -27,6 +27,7 @@ import static net.minecraft.client.render.entity.MobRenderer.ENTITY_RENDER_SCALE
 
 public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatue> {
     public static final @NotNull Map<@NotNull Block<?>, @NotNull String> BLOCK_SKIN_MAP = new HashMap<>();
+
     static {
         final @NotNull String basePath = "/assets/minecraft/textures/entity/statue/";
         BLOCK_SKIN_MAP.put(Blocks.STATUE_STONE_LOWER, basePath + "stone.png");
@@ -59,21 +60,21 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
         bindTexture(BLOCK_SKIN_MAP.getOrDefault(lowerBlock, BLOCK_SKIN_MAP.get(Blocks.STATUE_STONE_LOWER)));
         GL11.glPushMatrix();
         GL11.glTranslated(x + 0.5, y, z + 0.5);
-        final float rotation = (float)(meta * 360) / 16F;
+        final float rotation = (float) (meta * 360) / 16F;
         GL11.glRotatef(-rotation, 0.0F, 1.0F, 0.0F);
         GL11.glDisable(GL11.GL_CULL_FACE);
 
-            GL11.glPushMatrix();
-            GL11.glScalef(1 / ENTITY_RENDER_SCALE, 1 / ENTITY_RENDER_SCALE, -1 / ENTITY_RENDER_SCALE);
-            model.resetBones();
-            renderModel(tessellator, model, pose);
-            if (armorWearer != null) {
-                for (int i = 0; i < 4; i++) {
-                    renderArmor(tessellator, armorWearer, i, pose);
-                }
+        GL11.glPushMatrix();
+        GL11.glScalef(1 / ENTITY_RENDER_SCALE, 1 / ENTITY_RENDER_SCALE, -1 / ENTITY_RENDER_SCALE);
+        model.resetBones();
+        renderModel(tessellator, model, pose);
+        if (armorWearer != null) {
+            for (int i = 0; i < 4; i++) {
+                renderArmor(tessellator, armorWearer, i, pose);
             }
-            renderHeldItem(heldStack, isPigman);
-            GL11.glPopMatrix();
+        }
+        renderHeldItem(heldStack, isPigman);
+        GL11.glPopMatrix();
 
         GL11.glEnable(GL11.GL_CULL_FACE);
         GL11.glPopMatrix();
@@ -81,7 +82,7 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
     }
 
     private void renderHeldItem(final @Nullable ItemStack itemStack, final boolean isPigman) {
-        if(itemStack != null) {
+        if (itemStack != null) {
             GL12.glEnable(GL12.GL_RESCALE_NORMAL);
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             model(isPigman).translateToBone("rightItem");
@@ -110,7 +111,7 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
         renderShadow(Minecraft.getMinecraft().currentWorld, tessellator, tileEntity.x, tileEntity.y, tileEntity.z, x, y, z, 2.0f, partialTick);
     }
 
-    private boolean renderArmor(final @NotNull Tessellator tessellator, final @NotNull IArmorWearing<? super HumanArmorShape> armorWearer, final int layer, final TileEntityStatue.Pose pose) {
+    private boolean renderArmor(final @NotNull Tessellator tessellator, final @NotNull IArmorWearing<? super HumanArmorShape> armorWearer, final int layer, final TileEntityStatue.@NotNull Pose pose) {
         final ItemStack itemstack = armorWearer.getItemInArmorSlot(HumanArmorShape.values()[(armorWearer.getNumArmorSlots() - 1) - layer]);
         if (itemstack != null) {
             final Item item = itemstack.getItem();
@@ -120,8 +121,7 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
                 bindTexture("/assets/minecraft/textures/armor/quiver_golden.png");
             } else if (item == Items.ARMOR_BOOTS_ICESKATES) {
                 bindTexture("/assets/minecraft/textures/armor/skates.png");
-            } else if (item instanceof IArmorItem) {
-                final IArmorItem armorItem = (IArmorItem) item;
+            } else if (item instanceof IArmorItem<?> armorItem) {
                 if (armorItem.getArmorMaterial() == null) return false;
                 bindTexture(String.format("/assets/%s/textures/armor/%s_%d.png", armorItem.getArmorMaterial().identifier.namespace(), armorItem.getArmorMaterial().identifier.value(), (layer != 2 ? 1 : 2)));
             } else {
@@ -170,8 +170,7 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
         return false;
     }
 
-    private void renderShadow(final @NotNull World world, final @NotNull Tessellator tessellator, final int bx, final int by, final int bz, final double rx, final double ry, final double rz, final float opacity, final float partialTick)
-    {
+    private void renderShadow(final @NotNull World world, final @NotNull Tessellator tessellator, final int bx, final int by, final int bz, final double rx, final double ry, final double rz, final float opacity, final float partialTick) {
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         final TextureManager textureManager = this.renderDispatcher.textureManager;
@@ -182,9 +181,8 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
         tessellator.startDrawingQuads();
 
         final int blockId = world.getBlockId(bx, by - 1, bz);
-        if(blockId > 0 && world.getBlockLightValue(bx, by, bz) > 3)
-        {
-            renderShadowOnBlock(world, tessellator, Blocks.blocksList[blockId], bx, by, bz, rx, ry + (double)shadowOffs, rz, opacity, shadowSize);
+        if (blockId > 0 && world.getBlockLightValue(bx, by, bz) > 3) {
+            renderShadowOnBlock(world, tessellator, Blocks.blocksList[blockId], bx, by, bz, rx, ry + (double) shadowOffs, rz, opacity, shadowSize);
         }
 
         tessellator.draw();
@@ -193,38 +191,34 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
         GL11.glDepthMask(true);
     }
 
-    private void renderShadowOnBlock(final @NotNull World world, final @NotNull Tessellator tessellator, final Block<?> block, final int bx, final int by, final int bz, final double rx, final double ry, final double rz,
-                                     final float opacity, final float size)
-    {
-        if(!block.isCubeShaped())
-        {
+    private void renderShadowOnBlock(final @NotNull World world, final @NotNull Tessellator tessellator, final @NotNull Block<?> block, final int bx, final int by, final int bz, final double rx, final double ry, final double rz,
+                                     final float opacity, final float size) {
+        if (!block.isCubeShaped()) {
             return;
         }
         double brightness = world.getLightBrightness(bx, by, bz);
         if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
-        double alpha = ((double)opacity / 2D) * 0.5D * brightness;
-        if(alpha < 0.0D)
-        {
+        double alpha = ((double) opacity / 2D) * 0.5D * brightness;
+        if (alpha < 0.0D) {
             return;
         }
-        if(alpha > 1.0D)
-        {
+        if (alpha > 1.0D) {
             alpha = 1.0D;
         }
-        tessellator.setColorRGBA_F(1.0F, 1.0F, 1.0F, (float)alpha);
-        final AABB aabb = block.getCollisionBoundingBoxFromPool(world, bx, by - 1, bz);
-        if(aabb == null) {
+        tessellator.setColorRGBA_F(1.0F, 1.0F, 1.0F, (float) alpha);
+        final AABBdc aabb = block.getCollisionBoundingBoxFromPool(world, bx, by - 1, bz);
+        if (aabb == null) {
             return;
         }
         final double xMin = rx - 0.5f;
-        final double xMax = rx + (aabb.maxX - aabb.minX) - 0.5f;
-        final double yMin = (ry + (aabb.maxY - aabb.minY)) - 1.39;
+        final double xMax = rx + (aabb.maxX() - aabb.minX()) - 0.5f;
+        final double yMin = (ry + (aabb.maxY() - aabb.minY())) - 1.39;
         final double zMin = rz - 0.5f;
-        final double zMax = rz + (aabb.maxZ - aabb.minZ) - 0.5f;
-        final float f2 = (float)((rx - xMin) / 2D / (double)size + 0.5D);
-        final float f3 = (float)((rx - xMax) / 2D / (double)size + 0.5D);
-        final float f4 = (float)((rz - zMin) / 2D / (double)size + 0.5D);
-        final float f5 = (float)((rz - zMax) / 2D / (double)size + 0.5D);
+        final double zMax = rz + (aabb.maxZ() - aabb.minZ()) - 0.5f;
+        final float f2 = (float) ((rx - xMin) / 2D / (double) size + 0.5D);
+        final float f3 = (float) ((rx - xMax) / 2D / (double) size + 0.5D);
+        final float f4 = (float) ((rz - zMin) / 2D / (double) size + 0.5D);
+        final float f5 = (float) ((rz - zMax) / 2D / (double) size + 0.5D);
         tessellator.addVertexWithUV(xMin + 0.5f, yMin, zMin + 0.5f, f2, f4);
         tessellator.addVertexWithUV(xMin + 0.5f, yMin, zMax + 0.5f, f2, f5);
         tessellator.addVertexWithUV(xMax + 0.5f, yMin, zMax + 0.5f, f3, f5);
diff --git a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
index f1d29d593..9b7cac3e1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
+++ b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
@@ -87,13 +87,13 @@ public class GameWindowGLFW implements GameWindow {
 
     @Override
     public void init(Minecraft minecraft, int width, int height) {
-        mc = minecraft;
+        this.mc = minecraft;
 
-        boolean debug = (mc.gameSettings.developerMode.value || Version.BUILD_CHANNEL == BuildChannel.DEVELOPMENT || Global.DEBUG_MODE);
+        boolean debug = (this.mc.gameSettings.developerMode.value || Version.BUILD_CHANNEL == BuildChannel.DEVELOPMENT || Global.DEBUG_MODE);
 
         LOGGER.info("Initializing GLFW...");
         if (debug) {
-            glfwErrorCallback = GLFWErrorCallback.create(new GLFWLoggerCallback()).set();
+            this.glfwErrorCallback = GLFWErrorCallback.create(new GLFWLoggerCallback()).set();
         }
         if (!glfwInit()) {
             throw new RuntimeException("GLFW initialization failed!");
@@ -106,8 +106,8 @@ public class GameWindowGLFW implements GameWindow {
         glfwWindowHint(GLFW_DECORATED, 1);
 
         // Create window
-        window = glfwCreateWindow(width, height, "Better than Adventure! " + Global.VERSION, 0, 0);
-        if (window == NULL) {
+        this.window = glfwCreateWindow(width, height, "Better than Adventure! " + Global.VERSION, 0, 0);
+        if (this.window == NULL) {
             try (MemoryStack stack = MemoryStack.stackPush()) {
                 PointerBuffer b = stack.callocPointer(1);
                 glfwGetError(b);
@@ -120,33 +120,33 @@ public class GameWindowGLFW implements GameWindow {
             var w = stack.callocInt(1);
             var h = stack.callocInt(1);
 
-            glfwGetWindowSize(window, w, h);
+            glfwGetWindowSize(this.window, w, h);
             this.widthScreenCoords = w.get(0);
             this.heightScreenCoords = h.get(0);
 
-            glfwGetFramebufferSize(window, w, h);
+            glfwGetFramebufferSize(this.window, w, h);
             this.widthPixels = w.get(0);
             this.heightPixels = h.get(0);
         }
 
         // Center window
         MonitorInfo monitor = new MonitorInfo(glfwGetPrimaryMonitor());
-        glfwSetWindowPos(window, (monitor.widthScreenCoords - widthScreenCoords) / 2, (monitor.heightScreenCoords - heightScreenCoords) / 2);
+        glfwSetWindowPos(this.window, (monitor.widthScreenCoords - this.widthScreenCoords) / 2, (monitor.heightScreenCoords - this.heightScreenCoords) / 2);
 
         // Setup callbacks
-        glfwSetWindowSizeCallback(window, (window, ww, hh) -> {
+        glfwSetWindowSizeCallback(this.window, (window, ww, hh) -> {
             this.widthScreenCoords = Math.max(1, ww);
             this.heightScreenCoords = Math.max(1, hh);
-            wasResized = true;
+            this.wasResized = true;
         });
 
-        glfwSetFramebufferSizeCallback(window, (window, ww, hh) -> {
+        glfwSetFramebufferSizeCallback(this.window, (window, ww, hh) -> {
             this.widthPixels = Math.max(1, ww);
             this.heightPixels = Math.max(1, hh);
-            wasResized = true;
+            this.wasResized = true;
         });
 
-        glfwSetWindowFocusCallback(window, (window, focused) -> {
+        glfwSetWindowFocusCallback(this.window, (window, focused) -> {
             this.hasFocus = focused;
             if (Mouse.isGrabbed() && !focused) {
                 Mouse.setGrabbed(false);
@@ -167,21 +167,21 @@ public class GameWindowGLFW implements GameWindow {
                 }
                 GLFWImage iconGI = GLFWImage.create().set(res, res, icon);
                 gb.put(iconGI);
-                stbiIconImages.add(icon);
+                this.stbiIconImages.add(icon);
             }
-            glfwSetWindowIcon(window, gb.flip());
+            glfwSetWindowIcon(this.window, gb.flip());
         }
 
         // Show window
-        glfwShowWindow(window);
+        glfwShowWindow(this.window);
 
         // OpenGL setup
-        glfwMakeContextCurrent(window);
+        glfwMakeContextCurrent(this.window);
         GLCapabilities capabilities = GL.createCapabilities();
         if (capabilities.OpenGL43 && debug) {
             GL11.glEnable(GL43.GL_DEBUG_OUTPUT);
-            glDebugMessageCallback = new OpenGLLoggerCallback();
-            GL43.glDebugMessageCallback(glDebugMessageCallback, NULL);
+            this.glDebugMessageCallback = new OpenGLLoggerCallback();
+            GL43.glDebugMessageCallback(this.glDebugMessageCallback, NULL);
             LOGGER.info("GL4.3 supported, enabling GL Error logging");
         } else {
             LOGGER.info("GL4.3 not supported, cannot enable GL Error logging");
@@ -215,7 +215,7 @@ public class GameWindowGLFW implements GameWindow {
         }
 
         // Set Vsync
-        setVsync(mc.gameSettings.enableVsync.value);
+        setVsync(this.mc.gameSettings.enableVsync.value);
     }
 
     @Override
@@ -255,7 +255,7 @@ public class GameWindowGLFW implements GameWindow {
 
     @Override
     public void setWindowSize(int width, int height) {
-        glfwSetWindowSize(window, width, height);
+        glfwSetWindowSize(this.window, width, height);
     }
 
     @Override
@@ -265,22 +265,22 @@ public class GameWindowGLFW implements GameWindow {
 
     @Override
     public void toggleFullscreen() {
-        mc.gameSettings.fullscreen.value = !mc.gameSettings.fullscreen.value;
+        this.mc.gameSettings.fullscreen.value = !this.mc.gameSettings.fullscreen.value;
 
         updateWindowState();
     }
 
     @Override
     public void updateWindowState() {
-        if (!isFullscreen) {
+        if (!this.isFullscreen) {
             try (var stack = MemoryStack.stackPush()) {
                 var x = stack.callocInt(1);
                 var y = stack.callocInt(1);
-                glfwGetWindowPos(window, x, y);
+                glfwGetWindowPos(this.window, x, y);
 
                 var w = stack.callocInt(1);
                 var h = stack.callocInt(1);
-                glfwGetWindowSize(window, w, h);
+                glfwGetWindowSize(this.window, w, h);
 
                 this.windowPosX = x.get(0);
                 this.windowPosY = y.get(0);
@@ -289,42 +289,42 @@ public class GameWindowGLFW implements GameWindow {
             }
         }
 
-        boolean fullscreen = mc.gameSettings.fullscreen.value;
-        boolean borderless = mc.gameSettings.borderlessFullscreen.value;
+        boolean fullscreen = this.mc.gameSettings.fullscreen.value;
+        boolean borderless = this.mc.gameSettings.borderlessFullscreen.value;
 
-        glfwHideWindow(window);
+        glfwHideWindow(this.window);
 
         if (fullscreen && !borderless) {
             LOGGER.info("Setting window to FULLSCREEN...");
-            int x = windowPosX + windowWidth / 2;
-            int y = windowPosY + windowHeight / 2;
+            int x = this.windowPosX + this.windowWidth / 2;
+            int y = this.windowPosY + this.windowHeight / 2;
             MonitorInfo monitor = getMonitorAt(x, y);
 
             // Enable GLFW Fullscreen
-            glfwSetWindowMonitor(window, monitor.handle, monitor.posX, monitor.posY, monitor.widthScreenCoords, monitor.heightScreenCoords, monitor.refreshRate);
-            isFullscreen = true;
+            glfwSetWindowMonitor(this.window, monitor.handle, monitor.posX, monitor.posY, monitor.widthScreenCoords, monitor.heightScreenCoords, monitor.refreshRate);
+            this.isFullscreen = true;
         } else {
             // Disable GLFW Fullscreen
-            glfwSetWindowMonitor(window, 0, windowPosX, windowPosY, windowWidth, windowHeight, 0);
+            glfwSetWindowMonitor(this.window, 0, this.windowPosX, this.windowPosY, this.windowWidth, this.windowHeight, 0);
 
             if (fullscreen && borderless) {
                 LOGGER.info("Setting window to BORDERLESS FULLSCREEN...");
-                int x = windowPosX + windowWidth / 2;
-                int y = windowPosY + windowHeight / 2;
+                int x = this.windowPosX + this.windowWidth / 2;
+                int y = this.windowPosY + this.windowHeight / 2;
                 MonitorInfo monitor = getMonitorAt(x, y);
 
-                glfwSetWindowAttrib(window, GLFW_DECORATED, 0);
-                glfwSetWindowPos(window, monitor.posX, monitor.posY);
-                glfwSetWindowSize(window, monitor.widthScreenCoords, monitor.heightScreenCoords);
-                isFullscreen = true;
+                glfwSetWindowAttrib(this.window, GLFW_DECORATED, 0);
+                glfwSetWindowPos(this.window, monitor.posX, monitor.posY);
+                glfwSetWindowSize(this.window, monitor.widthScreenCoords, monitor.heightScreenCoords);
+                this.isFullscreen = true;
             } else {
                 LOGGER.info("Setting window to WINDOWED...");
-                glfwSetWindowAttrib(window, GLFW_DECORATED, 1);
-                isFullscreen = false;
+                glfwSetWindowAttrib(this.window, GLFW_DECORATED, 1);
+                this.isFullscreen = false;
             }
         }
 
-        glfwShowWindow(window);
+        glfwShowWindow(this.window);
     }
 
     public MonitorInfo getMonitorAt(int x, int y) {
@@ -347,7 +347,7 @@ public class GameWindowGLFW implements GameWindow {
     @Override
     public void displayCrashReport(UnexpectedThrowable unexpectedThrowable, int cause) {
         JFrame frame = new JFrame();
-        Panel panel = new PanelCrashReport(mc, unexpectedThrowable, cause);
+        Panel panel = new PanelCrashReport(this.mc, unexpectedThrowable, cause);
 
         panel.setPreferredSize(new java.awt.Dimension(1280, 720));
 
@@ -360,15 +360,15 @@ public class GameWindowGLFW implements GameWindow {
 
     @Override
     public int getFrequency() {
-        final long monitor = glfwGetWindowMonitor(window);
+        final long monitor = glfwGetWindowMonitor(this.window);
         if (monitor != NULL) {
             final GLFWVidMode vidMode = glfwGetVideoMode(monitor);
             if (vidMode != null) {
                 return vidMode.refreshRate();
             }
         }
-        int x = windowPosX + windowWidth / 2;
-        int y = windowPosY + windowHeight / 2;
+        int x = this.windowPosX + this.windowWidth / 2;
+        int y = this.windowPosY + this.windowHeight / 2;
         final MonitorInfo info = getMonitorAt(x, y);
         return info.refreshRate;
     }
@@ -382,43 +382,43 @@ public class GameWindowGLFW implements GameWindow {
         }
         Mouse.poll();
 
-        glfwSwapBuffers(window);
+        glfwSwapBuffers(this.window);
     }
 
     @Override
     public boolean shouldClose() {
-        return glfwWindowShouldClose(window);
+        return glfwWindowShouldClose(this.window);
     }
 
     @Override
     public int getWidthScreenCoords() {
-        return widthScreenCoords;
+        return this.widthScreenCoords;
     }
 
     @Override
     public int getHeightScreenCoords() {
-        return heightScreenCoords;
+        return this.heightScreenCoords;
     }
 
     @Override
     public int getWidthPixels() {
-        return widthPixels;
+        return this.widthPixels;
     }
 
     @Override
     public int getHeightPixels() {
-        return heightPixels;
+        return this.heightPixels;
     }
 
     @Override
     public boolean isFocused() {
-        return hasFocus;
+        return this.hasFocus;
     }
 
     @Override
     public boolean wasResized() {
-        if (wasResized) {
-            wasResized = false;
+        if (this.wasResized) {
+            this.wasResized = false;
             return true;
         }
         return false;
@@ -441,9 +441,9 @@ public class GameWindowGLFW implements GameWindow {
     @Override
     public void free() {
         Callbacks.glfwFreeCallbacks(this.window);
-        if (glfwErrorCallback != null) glfwErrorCallback.free();
-        if (glDebugMessageCallback != null) glDebugMessageCallback.free();
-        stbiIconImages.forEach(STBImage::stbi_image_free);
+        if (this.glfwErrorCallback != null) this.glfwErrorCallback.free();
+        if (this.glDebugMessageCallback != null) this.glDebugMessageCallback.free();
+        this.stbiIconImages.forEach(STBImage::stbi_image_free);
     }
 
     public static class MonitorInfo {
@@ -464,13 +464,13 @@ public class GameWindowGLFW implements GameWindow {
                 var x = stack.callocInt(1);
                 var y = stack.callocInt(1);
                 glfwGetMonitorPos(monitor, x, y);
-                posX = x.get(0);
-                posY = y.get(0);
+                this.posX = x.get(0);
+                this.posY = y.get(0);
             }
 
-            widthScreenCoords = vidmode.width();
-            heightScreenCoords = vidmode.height();
-            refreshRate = vidmode.refreshRate();
+            this.widthScreenCoords = vidmode.width();
+            this.heightScreenCoords = vidmode.height();
+            this.refreshRate = vidmode.refreshRate();
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java
index be3214445..29df947b4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java
@@ -1,78 +1,82 @@
 package net.minecraft.client.render.worldtype;
 
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3f;
+import org.joml.Vector3fc;
 
 public class WorldTypeFX {
-    public final WorldType worldType;
+    public final @NotNull WorldType worldType;
 
     private boolean hasClouds = true;
     private boolean hasSky = true;
     private boolean hasGround = true;
     private boolean hasAurora = false;
-    private Float cloudHeight = null;
+    private @Nullable Float cloudHeight = null;
 
-    public WorldTypeFX(WorldType worldType) {
+    public WorldTypeFX(@NotNull WorldType worldType) {
         this.worldType = worldType;
     }
 
-    public WorldTypeFX setHasClouds(boolean flag) {
+    public @NotNull WorldTypeFX setHasClouds(boolean flag) {
         this.hasClouds = flag;
         return this;
     }
 
-    public WorldTypeFX setHasSky(boolean flag) {
+    public @NotNull WorldTypeFX setHasSky(boolean flag) {
         this.hasSky = flag;
         return this;
     }
 
-    public WorldTypeFX setHasGround(boolean flag) {
+    public @NotNull WorldTypeFX setHasGround(boolean flag) {
         this.hasGround = flag;
         return this;
     }
 
-    public WorldTypeFX setHasAurora(boolean flag) {
+    public @NotNull WorldTypeFX setHasAurora(boolean flag) {
         this.hasAurora = flag;
         return this;
     }
 
-    public WorldTypeFX setCloudHeight(float cloudHeight) {
+    public @NotNull WorldTypeFX setCloudHeight(float cloudHeight) {
         this.cloudHeight = cloudHeight;
         return this;
     }
 
     public boolean hasClouds() {
-        return hasClouds;
+        return this.hasClouds;
     }
 
     public boolean hasSky() {
-        return hasSky;
+        return this.hasSky;
     }
 
     public float getCloudHeight() {
-        if (cloudHeight == null) {
-            return (worldType.getMaxY() + 1) - 20;
+        if (this.cloudHeight == null) {
+            return (this.worldType.getMaxY() + 1) - 20;
         }
-        return cloudHeight;
+        return this.cloudHeight;
     }
 
     public boolean hasGround() {
-        return hasGround;
+        return this.hasGround;
     }
 
     public boolean hasAurora() {
-        return hasAurora;
+        return this.hasAurora;
     }
 
-    public Vec3 getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick) {
-        return Vec3.fromPool(1.0, 1.0, 1.0);
+    public @NotNull Vector3fc getFogColor(@NotNull World world, double x, double y, double z, float celestialAngle, float partialTick) {
+        return new Vector3f(1.0f, 1.0f, 1.0f);
     }
 
-    public float[] getSunriseColor(float timeOfDay, float partialTick) {
+    public float @Nullable [] getSunriseColor(float timeOfDay, float partialTick) {
         return new float[4];
     }
 
-    public void playerAnimationTick(World world, Player player) { }
+    public void playerAnimationTick(@NotNull World world, @NotNull Player player) {
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDrift.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDrift.java
index cd90bba49..785fb2aa1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDrift.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDrift.java
@@ -2,9 +2,13 @@ package net.minecraft.client.render.worldtype;
 
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3f;
+import org.joml.Vector3fc;
 
 public class WorldTypeFXDrift extends WorldTypeFX{
     public WorldTypeFXDrift(WorldType worldType) {
@@ -12,7 +16,7 @@ public class WorldTypeFXDrift extends WorldTypeFX{
     }
 
     @Override
-    public float[] getSunriseColor(float timeOfDay, float partialTick) {
+    public float @Nullable [] getSunriseColor(float timeOfDay, float partialTick) {
         float[] sunriseCol = new float[4];
         float f2 = 0.4F;
         float f3 = MathHelper.cos(timeOfDay * MathHelper.PI * 2.0F) - 0.0F;
@@ -32,17 +36,13 @@ public class WorldTypeFXDrift extends WorldTypeFX{
     }
 
     @Override
-    public Vec3 getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick) {
+    public @NotNull Vector3fc getFogColor(@NotNull World world, double x, double y, double z, float celestialAngle, float partialTick) {
         float f2 = MathHelper.cos(celestialAngle * MathHelper.PI * 2.0F) * 2.0F + 0.5F;
         f2 = MathHelper.clamp(f2, 0.0f, 1.0f);
         float r, g, b;
 
         if (Colorizers.fog.isEnabled()) {
-            int x1 = MathHelper.floor(x);
-            int y1 = MathHelper.floor(y);
-            int z1 = MathHelper.floor(z);
-
-            int color = Colorizers.fog.getColor(world, x1, y1, z1);
+            int color = Colorizers.fog.getColor(world, new TilePos(x, y, z));
 
             r = ((color >> 16) & 0xFF) / 255.0f;
             g = ((color >> 8) & 0xFF) / 255.0f;
@@ -56,6 +56,6 @@ public class WorldTypeFXDrift extends WorldTypeFX{
         r *= f2 * 0.94F + 0.06F;
         g *= f2 * 0.94F + 0.06F;
         b *= f2 * 0.91F + 0.09F;
-        return Vec3.fromPool(r, g, b);
+        return new Vector3f(r, g, b);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXEmpty.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXEmpty.java
index 5ecd801fd..3223ccb6c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXEmpty.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXEmpty.java
@@ -1,9 +1,12 @@
 package net.minecraft.client.render.worldtype;
 
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3f;
+import org.joml.Vector3fc;
 
 public class WorldTypeFXEmpty extends WorldTypeFX{
     public WorldTypeFXEmpty(WorldType worldType) {
@@ -11,7 +14,7 @@ public class WorldTypeFXEmpty extends WorldTypeFX{
     }
 
     @Override
-    public Vec3 getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick) {
+    public @NotNull Vector3fc getFogColor(@NotNull World world, double x, double y, double z, float celestialAngle, float partialTick) {
         float f2 = MathHelper.cos(celestialAngle * MathHelper.PI * 2.0F) * 2.0F + 0.5F;
         if (f2 < 0.0F) {
             f2 = 0.0F;
@@ -25,12 +28,11 @@ public class WorldTypeFXEmpty extends WorldTypeFX{
         r *= f2 * 0.94F + 0.06F;
         g *= f2 * 0.94F + 0.06F;
         b *= f2 * 0.91F + 0.09F;
-        return Vec3.fromPool(r, g, b);
+        return new Vector3f(r, g, b);
     }
 
     @Override
-    public float[] getSunriseColor(float timeOfDay, float partialTick) {
-        float[] sunriseCol = new float[4];
+    public float @Nullable [] getSunriseColor(float timeOfDay, float partialTick) {
         float f2 = 0.4F;
         float f3 = MathHelper.cos(timeOfDay * MathHelper.PI * 2.0F) - 0.0F;
         float f4 = -0F;
@@ -38,13 +40,13 @@ public class WorldTypeFXEmpty extends WorldTypeFX{
             float c = ((f3 - f4) / f2) * 0.5F + 0.5F;
             float a = 1.0F - (1.0F - MathHelper.sin(c * MathHelper.PI)) * 0.99F;
             a *= a;
+            float[] sunriseCol = new float[4];
             sunriseCol[0] = c * 0.3F + 0.7F;
             sunriseCol[1] = c * c * 0.7F + 0.2F;
             sunriseCol[2] = c * c * 0.0F + 0.2F;
             sunriseCol[3] = a;
             return sunriseCol;
-        } else {
-            return null;
         }
+        return null;
     }
 }
